package com.sky.ioc.config;

import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

import javax.net.ssl.HttpsURLConnection;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.time.Duration;
import java.time.temporal.ChronoUnit;

@Configuration
public class RestTemplateConfig {

    private static RestTemplateBuilder builder = null;

    static {
        builder = new RestTemplateBuilder(restTemplate -> restTemplate.setRequestFactory(new SimpleClientHttpRequestFactory() {
            @Override
            protected void prepareConnection(HttpURLConnection connection, String httpMethod) throws IOException {
                if (connection instanceof HttpsURLConnection) {
                    ((HttpsURLConnection) connection).setHostnameVerifier((s, sslSession) -> true);
                }
                super.prepareConnection(connection, httpMethod);
            }
        }))
                // 超时时间
                .setConnectTimeout(Duration.of(5*60, ChronoUnit.SECONDS))
                .setReadTimeout(Duration.of(5*60, ChronoUnit.SECONDS));
    }

    @Bean
    public RestTemplate restTemplate(){
        return build();
    }


    public RestTemplate build() {
        return builder.build();
    }
    
}
