package com.sky.ioc.controller.message;

import com.sky.ioc.service.message.MessageService;
import com.sky.ioc.tool.ReturnMsg;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Api(tags = "消息管理")
@Slf4j
@RestController
@RequestMapping("/message")
public class MessageController {

    @Autowired
    MessageService messageService;

    @ApiOperation("获取消息列表")
    @GetMapping(value = "/message_list")
    public ReturnMsg getMessageList() {
        return messageService.getList();
    }

    @ApiOperation("获取消息列表")
    @GetMapping(value = "/messager_module")
    public ReturnMsg getMessagerModuleList() {
        return messageService.getTypeList();
    }

    @ApiOperation("获取消息列表")
    @GetMapping(value = "/search")
    public ReturnMsg search(@RequestParam(name = "name",defaultValue = "") String name,
                            @RequestParam(name = "type",defaultValue = "") String type,
                            @RequestParam(name = "start_time",defaultValue = "") String start_time,
                            @RequestParam(name = "end_time",defaultValue = "") String end_time) {
        return messageService.search(name,type,start_time,end_time);
    }

    @ApiOperation("获取消息详情")
    @GetMapping(value = "/message")
    public ReturnMsg message(@RequestParam(name = "id",required = true) Integer id) {
        return messageService.getMessage(id);
    }
    @ApiOperation("删除消息")
    @DeleteMapping(value = "/message")
    public ReturnMsg delMessage(@RequestParam(name = "message_id",required = true) Integer message_id) {
        return messageService.delMessage(message_id);
    }

    @ApiOperation("修改消息")
    @PutMapping(value = "/message")
    public ReturnMsg editMessage(@RequestParam(name = "message_id",required = true) Integer message_id) {
        return messageService.delMessage(message_id);
    }
}
